-- name: [CS] Super Paper Villains
-- description: ochunks \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!



local E_MODEL_OCHUNKS = smlua_model_util_get_id("ochunks_geo")
local E_MODEL_OCHUNKS_STEM = smlua_model_util_get_id("ochunks_stem_geo")

local E_MODEL_MIMI_DEFAULT = smlua_model_util_get_id("mimi_default_geo")
local E_MODEL_MIMI_ADVENTURE = smlua_model_util_get_id("mimi_adventure_geo")
local E_MODEL_MIMI_BANK = smlua_model_util_get_id("mimi_bank_geo")
local E_MODEL_MIMI_BEACH = smlua_model_util_get_id("mimi_beach_geo")
local E_MODEL_MIMI_CHEER = smlua_model_util_get_id("mimi_cheer_geo")
local E_MODEL_MIMI_FORMAL = smlua_model_util_get_id("mimi_formal_geo")
local E_MODEL_MIMI_MAID = smlua_model_util_get_id("mimi_maid_geo")
local E_MODEL_MIMI_POST = smlua_model_util_get_id("mimi_post_geo")
local E_MODEL_MIMI_SAMMER = smlua_model_util_get_id("mimi_sammer_geo")
local E_MODEL_MIMI_SUIT = smlua_model_util_get_id("mimi_suit_geo")

local E_MODEL_CBLECK = smlua_model_util_get_id("bleck_geo")

local E_MODEL_MRL= smlua_model_util_get_id("mrl_geo")
local E_MODEL_SHADOO= smlua_model_util_get_id("shadoo_geo")

local E_MODEL_NASTASIA = smlua_model_util_get_id("nastasia_geo")

local E_MODEL_DIMENTIO = smlua_model_util_get_id("dimentio_geo")


local TEX_OCHUNKS = get_texture_info("ochunks_icon")
local TEX_MIMI = get_texture_info("mimi_icon")
local TEX_CBLECK = get_texture_info("bleck_icon")
local TEX_MRL = get_texture_info("mrl_icon")
local TEX_SHADOO = get_texture_info("shadoo_icon")
local TEX_NASTASIA = get_texture_info("nastasia_icon")
local TEX_DIMENTIO = get_texture_info("dimentio_icon")


local TEXT_MOD_NAME = "[CS] SUPER PAPER VILLAINS"

local E_MODEL_STAR_1PH = smlua_model_util_get_id("1_pheart_geo")
local TEX_STAR_1PH = get_texture_info("1_pheart")

local E_MODEL_STAR_2PH = smlua_model_util_get_id("2_pheart_geo")
local TEX_STAR_2PH = get_texture_info("2_pheart")

local E_MODEL_STAR_3PH = smlua_model_util_get_id("3_pheart_geo")
local TEX_STAR_3PH = get_texture_info("3_pheart")

local E_MODEL_STAR_4PH = smlua_model_util_get_id("4_pheart_geo")
local TEX_STAR_4PH = get_texture_info("4_pheart")

local E_MODEL_STAR_5PH = smlua_model_util_get_id("5_pheart_geo")
local TEX_STAR_5PH = get_texture_info("5_pheart")

local E_MODEL_STAR_6PH = smlua_model_util_get_id("6_pheart_geo")
local TEX_STAR_6PH = get_texture_info("6_pheart")

local E_MODEL_STAR_7PH = smlua_model_util_get_id("7_pheart_geo")
local TEX_STAR_7PH = get_texture_info("7_pheart")

local E_MODEL_STAR_8PH = smlua_model_util_get_id("8_pheart_geo")
local TEX_STAR_8PH = get_texture_info("8_pheart")

local E_MODEL_STAR_DARKPH = smlua_model_util_get_id("dark_pheart_geo")
local TEX_STAR_DARKPH = get_texture_info("dark_pheart")

local VOICETABLE_OCHUNKS = {
    [CHAR_SOUND_ATTACKED] = 'oc_Attacked.ogg',
    [CHAR_SOUND_COUGHING1] = 'oc_COUGHING1.ogg',
    [CHAR_SOUND_COUGHING2] = 'oc_COUGHING2.ogg',
    [CHAR_SOUND_COUGHING3] = 'oc_COUGHING3.ogg',
    [CHAR_SOUND_DOH] = 'oc_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'oc_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'oc_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'oc_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'oc_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'oc_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'oc_HAHA_2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'oc_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = {'oc_HOOHOO.ogg', 'oc_HOOHOO2.ogg'},
    [CHAR_SOUND_HRMM] = 'oc_HRMM.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'oc_IMA_TIRED.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'oc_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'oc_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'oc_ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 'oc_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'oc_OOOF2.ogg',
    [CHAR_SOUND_PANTING] = 'oc_PANTING.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'oc_PANTING_COLD.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'oc_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'oc_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'oc_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'oc_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_SNORING1] = 'oc_SNORING1.ogg',
    [CHAR_SOUND_SNORING2] = 'oc_SNORING2.ogg',
    [CHAR_SOUND_SNORING3] = {'oc_SNORING2.ogg', 'oc_SNORING1.ogg', 'oc_SNORING3.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'oc_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'oc_UH.ogg',
    [CHAR_SOUND_UH2] = 'oc_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'oc_UH2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'oc_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'oc_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_WHOA] = 'oc_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'oc_YAHOO.ogg',
    [CHAR_SOUND_YAWNING] = 'oc_YAWNING.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'oc_YAHOO.ogg', 'oc_YAHOO_WAHA_YIPPEE1.ogg', 'oc_YAHOO_WAHA_YIPPEE2.ogg', 'oc_YAHOO_WAHA_YIPPEE3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'oc_YAH_WAH_HOO.ogg', 'oc_YAH_WAH_HOO2.ogg'},
    }


local VOICETABLE_CBLECK = {
    [CHAR_SOUND_ATTACKED] = 'cb_CHAR_SOUND_ATTACKED.ogg',
   -- [CHAR_SOUND_COUGHING1] = 'cb_CHAR_SOUND_COUGHING1.ogg',
   -- [CHAR_SOUND_COUGHING2] = 'cb_CHAR_SOUND_COUGHING2.ogg',
   -- [CHAR_SOUND_COUGHING3] = 'cb_CHAR_SOUND_COUGHING3.ogg',
    [CHAR_SOUND_DOH] = 'cb_CHAR_SOUND_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'cb_CHAR_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'cb_CHAR_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'cb_CHAR_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'cb_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'cb_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'cb_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'cb_CHAR_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = {'cb_CHAR_SOUND_HOOHOO.ogg'},
    [CHAR_SOUND_HRMM] = 'cb_CHAR_SOUND_HRMM.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'cb_CHAR_SOUND_IMA_TIRED.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'cb_CHAR_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'cb_CHAR_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'cb_CHAR_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 'cb_CHAR_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'cb_CHAR_SOUND_OOOF2.ogg',
    [CHAR_SOUND_PANTING] = 'cb_CHAR_SOUND_PANTING.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'cb_CHAR_SOUND_PANTING_COLD.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'cb_CHAR_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'cb_CHAR_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'cb_CHAR_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'cb_CHAR_SOUND_SO_LONGA_BOWSER.ogg',
   -- [CHAR_SOUND_SNORING1] = 'cb_SNORING1.ogg',
   -- [CHAR_SOUND_SNORING2] = 'cb_SNORING2.ogg',
    [CHAR_SOUND_SNORING3] = 'cb_CHAR_SOUND_SNORING3.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'cb_CHAR_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'cb_CHAR_SOUND_UH.ogg',
    [CHAR_SOUND_UH2] = 'cb_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'cb_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'cb_CHAR_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'cb_CHAR_SOUND_YAH_WAH_HOO2.ogg',
    [CHAR_SOUND_WHOA] = 'cb_CHAR_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'cb_CHAR_SOUND_YAHOO.ogg',
    [CHAR_SOUND_YAWNING] = 'cb_CHAR_SOUND_YAWNING.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'cb_CHAR_SOUND_YAHOO_WAHA_YIPPEE1.ogg', 'cb_CHAR_SOUND_YAHOO_WAHA_YIPPEE2.ogg', 'cb_CHAR_SOUND_YAHOO_WAHA_YIPPEE3.ogg', 'cb_CHAR_SOUND_YAHOO.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'cb_CHAR_SOUND_YAH_WAH_HOO1.ogg', 'cb_CHAR_SOUND_YAH_WAH_HOO2.ogg', 'cb_CHAR_SOUND_YAH_WAH_HOO3.ogg'},
}

local VOICETABLE_MIMI = {
    [CHAR_SOUND_ATTACKED] = 'mimi_CHAR_SOUND_ATTACKED.ogg',
    [CHAR_SOUND_COUGHING1] = 'mimi_CHAR_SOUND_COUGHING1.ogg',
    [CHAR_SOUND_COUGHING2] = 'mimi_CHAR_SOUND_COUGHING2.ogg',
    [CHAR_SOUND_COUGHING3] = 'mimi_CHAR_SOUND_COUGHING3.ogg',
    [CHAR_SOUND_DOH] = 'mimi_CHAR_SOUND_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'mimi_CHAR_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'mimi_CHAR_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'mimi_CHAR_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'mimi_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'mimi_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'mimi_CHAR_SOUND_HAHA_2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'mimi_CHAR_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 'mimi_CHAR_SOUND_HOOHOO.ogg',
    [CHAR_SOUND_HRMM] = 'mimi_CHAR_SOUND_HRMM.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'mimi_CHAR_SOUND_IMA_TIRED.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'mimi_CHAR_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'mimi_CHAR_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'mimi_CHAR_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'mimi_CHAR_SOUND_OKEY_DOKEY.ogg',    
    [CHAR_SOUND_OOOF] = 'mimi_CHAR_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'mimi_CHAR_SOUND_OOOF2.ogg',
    [CHAR_SOUND_PANTING] = 'mimi_CHAR_SOUND_PANTING.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'mimi_CHAR_SOUND_PANTING_COLD.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'mimi_CHAR_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'mimi_CHAR_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'mimi_CHAR_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'mimi_CHAR_SOUND_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_SNORING1] = 'mimi_CHAR_SOUND_SNORING1.ogg',
    [CHAR_SOUND_SNORING2] = 'mimi_CHAR_SOUND_SNORING2.ogg',
    [CHAR_SOUND_SNORING3] = {'mimi_CHAR_SOUND_SNORING1.ogg', 'mimi_CHAR_SOUND_SNORING2.ogg', 'mimi_CHAR_SOUND_SNORING3.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'mimi_CHAR_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'mimi_CHAR_SOUND_UH.ogg',
    [CHAR_SOUND_UH2] = 'mimi_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'mimi_CHAR_SOUND_UH2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'mimi_CHAR_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'mimi_CHAR_SOUND_WAH2.ogg',
    [CHAR_SOUND_WHOA] = 'mimi_CHAR_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'mimi_CHAR_SOUND_YAHOO.ogg',
    [CHAR_SOUND_YAWNING] = 'mimi_CHAR_SOUND_YAWNING.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'mimi_CHAR_SOUND_YAHOO_triple.ogg', 'mimi_CHAR_SOUND_WAHA_triple.ogg', 'mimi_CHAR_SOUND_YIPPEE_triple.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'mimi_CHAR_SOUND_YAH.ogg', 'mimi_CHAR_SOUND_WAH.ogg', 'mimi_CHAR_SOUND_HOO.ogg'},
}

local VOICETABLE_NASTASIA = {
    [CHAR_SOUND_ATTACKED] = 'NAS_SOUND_ATTACKED.ogg',
    [CHAR_SOUND_COUGHING1] = 'NAS_SOUND_COUGHING1.ogg',
    [CHAR_SOUND_COUGHING2] = 'NAS_SOUND_COUGHING2.ogg',
    [CHAR_SOUND_COUGHING3] = 'NAS_SOUND_COUGHING3.ogg',
    [CHAR_SOUND_DOH] = 'NAS_SOUND_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'NAS_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'NAS_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'NAS_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'NAS_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'NAS_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'NAS_SOUND_HAHA.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'NAS_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 'NAS_SOUND_HOOHOO.ogg',
    [CHAR_SOUND_HRMM] = 'NAS_SOUND_HRMM.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'NAS_SOUND_IMA_TIRED.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'NAS_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'NAS_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'NAS_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'NAS_SOUND_OKEY_DOKEY.ogg',
    [CHAR_SOUND_OOOF] = 'NAS_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'NAS_SOUND_OOOF.ogg',
    [CHAR_SOUND_PANTING] = 'NAS_SOUND_PANTING.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'NAS_SOUND_PANTING_COLD.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'NAS_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'NAS_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'NAS_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'NAS_SOUND_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_SNORING1] = 'NAS_SOUND_SNORING1.ogg',
    [CHAR_SOUND_SNORING2] = 'NAS_SOUND_SNORING2.ogg',
    [CHAR_SOUND_SNORING3] = {'NAS_SOUND_SNORING1.ogg', 'NAS_SOUND_SNORING2.ogg', 'NAS_SOUND_SNORING3.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'NAS_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'NAS_SOUND_UH.ogg',
    [CHAR_SOUND_UH2] = 'NAS_SOUND_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'NAS_SOUND_UH2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'NAS_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'NAS_SOUND_YAH_WAH_HOO_2.ogg',
    [CHAR_SOUND_WHOA] = 'NAS_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'NAS_SOUND_YAHOO.ogg',
    --[CHAR_SOUND_YAWNING] = 'NAS_SOUND_YAWNING.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'NAS_SOUND_YAHOO_WAHA_YIPPEE_1.ogg', 'NAS_SOUND_YAHOO_WAHA_YIPPEE_2.ogg', 'NAS_SOUND_YAHOO_WAHA_YIPPEE_3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'NAS_SOUND_YAH_WAH_HOO_1.ogg', 'NAS_SOUND_YAH_WAH_HOO_2.ogg', 'NAS_SOUND_YAH_WAH_HOO_3.ogg'},
}

local VOICETABLE_DIMENTIO = {
    [CHAR_SOUND_ATTACKED] = 'DIM_SOUND_ATTACKED.ogg',
    [CHAR_SOUND_COUGHING1] = 'DIM_SOUND_COUGHING1.ogg',
    [CHAR_SOUND_COUGHING2] = 'DIM_SOUND_COUGHING2.ogg',
    [CHAR_SOUND_COUGHING3] = 'DIM_SOUND_COUGHING3.ogg',
    [CHAR_SOUND_DOH] = 'DIM_SOUND_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'DIM_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'DIM_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'DIM_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'DIM_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'DIM_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'DIM_SOUND_HAHA.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'DIM_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 'DIM_SOUND_HOOHOO.ogg',
    [CHAR_SOUND_HRMM] = 'DIM_SOUND_HRMM.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'DIM_SOUND_IMA_TIRED.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'DIM_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'DIM_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'DIM_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'DIM_SOUND_OKEY_DOKEY.ogg',
    [CHAR_SOUND_OOOF] = 'DIM_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'DIM_SOUND_OOOF.ogg',
    [CHAR_SOUND_PANTING] = 'DIM_SOUND_PANTING.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'DIM_SOUND_PANTING_COLD.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'DIM_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'DIM_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'DIM_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'DIM_SOUND_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_SNORING1] = 'DIM_SOUND_SNORING1.ogg',
    [CHAR_SOUND_SNORING2] = 'DIM_SOUND_SNORING2.ogg',
    [CHAR_SOUND_SNORING3] = {'DIM_SOUND_SNORING1.ogg', 'DIM_SOUND_SNORING2.ogg', 'DIM_SOUND_SNORING3.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'DIM_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'DIM_SOUND_UH.ogg',
    [CHAR_SOUND_UH2] = 'DIM_SOUND_UH.ogg',
    [CHAR_SOUND_UH2_2] = 'DIM_SOUND_UH.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'DIM_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'DIM_SOUND_YAH_WAH_HOO2.ogg',
    [CHAR_SOUND_WHOA] = 'DIM_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'DIM_SOUND_YAHOO_WAHA_YIPPEE2.ogg',
    --[CHAR_SOUND_YAWNING] = 'DIM_SOUND_YAWNING.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'DIM_SOUND_YAHOO_WAHA_YIPPEE1.ogg', 'DIM_SOUND_YAHOO_WAHA_YIPPEE2.ogg', 'DIM_SOUND_YAHOO_WAHA_YIPPEE3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'DIM_SOUND_YAH_WAH_HOO1.ogg', 'DIM_SOUND_YAH_WAH_HOO2.ogg', 'DIM_SOUND_YAH_WAH_HOO3.ogg'},
}

local capOCHUNKS = {
    normal = smlua_model_util_get_id("ochunks_cap_geo"),
    wing = smlua_model_util_get_id("ochunks_wing_cap_geo"),
    metal = smlua_model_util_get_id("ochunks_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("ochunks_metal_wing_cap_geo")
}

local capMIMI = {
    normal = smlua_model_util_get_id("mimi_cap_geo"),
    wing = smlua_model_util_get_id("mimi_wing_cap_geo"),
    metal = smlua_model_util_get_id("mimi_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mimi_metal_wing_cap_geo")
}

local capCBLECK = {
    normal = smlua_model_util_get_id("blecks_cap_geo"),
    wing = smlua_model_util_get_id("blecks_wing_cap_geo"),
    metal = smlua_model_util_get_id("blecks_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("blecks_metal_wing_cap_geo")
}

local capMRL = {
    normal = smlua_model_util_get_id("mrls_cap_geo"),
    wing = smlua_model_util_get_id("mrls_wing_cap_geo"),
    metal = smlua_model_util_get_id("mrls_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mrls_metal_wing_cap_geo")
}

local capSHADOO = {
    normal = smlua_model_util_get_id("shadoos_cap_geo"),
    wing = smlua_model_util_get_id("shadoos_wing_cap_geo"),
    metal = smlua_model_util_get_id("mrls_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mrls_metal_wing_cap_geo")
}

local capNASTASIA = {
    normal = smlua_model_util_get_id("nastasias_cap_geo"),
    wing = smlua_model_util_get_id("nastasias_wing_cap_geo"),
    metal = smlua_model_util_get_id("nastasias_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("nastasias_metal_wing_cap_geo")
}

local capDIMENTIO = {
    normal = smlua_model_util_get_id("dimentios_cap_geo"),
    wing = smlua_model_util_get_id("dimentios_wing_cap_geo"),
    metal = smlua_model_util_get_id("dimentios_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("dimentios_metal_wing_cap_geo")
}


local PALETTE_OCHUNKS = {
    [SHIRT] = "DE1A0C",
    [SHOES] = "1A0901",
    [HAIR] = "A7530A",
    [CAP] = "CCB334",
    [PANTS] = "98795C",
    [GLOVES] = "C0CDCF",
    [SKIN] = "DFCDA7",
    [EMBLEM] = "ffffff",
}

local PALETTE_OCHUNKS_STEM = {
    [SHIRT] = "DE1A0C",
    [SHOES] = "1A0901",
    [HAIR] = "A7530A",
    [CAP] = "CCB334",
    [PANTS] = "98795C",
    [GLOVES] = "C0CDCF",
    [SKIN] = "DFCDA7",
    [EMBLEM] = "9DFF63",
}

local PALETTE_MIMI_DEFAULT = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "ffffff",
    [CAP] = "E70818",
    [PANTS] = "FFDF08",
    [GLOVES] = "FFFFFF",
    [SKIN] = "ffffff",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_POST = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "ffffff",
    [CAP] = "8C96D6",
    [PANTS] = "944DBD",
    [GLOVES] = "FFFFD6",
    [SKIN] = "ffffff",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_BEACH = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "AD6929",
    [CAP] = "8C96D6",
    [PANTS] = "FF0031",
    [GLOVES] = "FFFFFF",
    [SKIN] = "ffffff",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_BANK = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "FFFFFF",
    [CAP] = "E70818",
    [PANTS] = "084994",
    [GLOVES] = "FFFFFF",
    [SKIN] = "ffffff",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_SAMMER = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "EF7100",
    [CAP] = "CE1431",
    [PANTS] = "FF0031",
    [GLOVES] = "FFFFEF",
    [SKIN] = "EFC300",
    [EMBLEM] = "F75D42",
}

local PALETTE_MIMI_FORMAL = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "EF7100",
    [CAP] = "CE1431",
    [PANTS] = "FF8AA5",
    [GLOVES] = "FFC3D6",
    [SKIN] = "FFFBAD",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_ADVENTURE = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "AD8218",
    [CAP] = "AD3418",
    [PANTS] = "315910",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFFBAD",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_SUIT = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "AD8218",
    [CAP] = "FF00E7",
    [PANTS] = "08B2FF",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFFBAD",
    [EMBLEM] = "ffffff",
}
local PALETTE_MIMI_MAID = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "FFFFFF",
    [CAP] = "FFFFFF",
    [PANTS] = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFFFFF",
    [EMBLEM] = "ffffff",
}

local PALETTE_MIMI_CHEER = {
    [SHIRT] = "A2E229",
    [SHOES] = "060405",
    [HAIR] = "FFFFFF",
    [CAP] = "E70818",
    [PANTS] = "FF7900",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFFFFF",
    [EMBLEM] = "ffffff",
}

local PALETTE_CBLECK = {
    [SHIRT] = "D42B08",
    [SHOES] = "732121",
    [HAIR] = "3C3C3C",
    [CAP] = "FF2C50",
    [PANTS] = "2844BD",
    [GLOVES] = "C0CDCF",
    [SKIN] = "E3DCCC",
    [EMBLEM] = "D3B954",
}

local PALETTE_MRL = {
    [SHIRT] = "00B22A",
    [SHOES] = "494949",
    [HAIR] = "812D00",
    [CAP] = "00B22A",
    [PANTS] = "1F1F1F",
    [GLOVES] = "B5B5AB",
    [SKIN] = "FFB87A",
    [EMBLEM] = "DB5800",
}

local PALETTE_SHADOO = {
    [SHIRT] = "191919",
    [SHOES] = "191919",
    [HAIR] = "191919",
    [CAP] = "191919",
    [PANTS] = "191919",
    [GLOVES] = "191919",
    [SKIN] = "191919",
    [EMBLEM] = "191919",
}

local PALETTE_NASTASIA= {
    [SHIRT] = "5AB5EF",
    [SHOES] = "535563",
    [HAIR] = "E755C6",
    [CAP] = "C64900",
    [PANTS] = "BFD1C7",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFFFFF",
    [EMBLEM] = "BBBBBB",
}

local PALETTE_DIMENTIO= {
    [SHIRT] = "EF63F7",
    [SHOES] = "000000",
    [HAIR] = "000000",
    [CAP] = "FBCF0A",
    [PANTS] = "FFFEA4",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFFFFF",
    [EMBLEM] = "FFFFFF",
}

--[[
local PM_OCHUNKS= {
    label = {
        left = get_texture_info("ochunks_pm1"),
        right = get_texture_info("ochunks_pm2"),
    },
    pie = { 
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
        
    }
}
]]

cbleckanims = {
    [CHAR_ANIM_RUNNING] = 'cbleck_running',
    [CHAR_ANIM_TURNING_PART1] = 'cbleck_turning_part1',
    [CHAR_ANIM_TURNING_PART2] = 'cbleck_turning_part2',
    [CHAR_ANIM_SKID_ON_GROUND] = 'cbleck_skid_on_ground',
}

dimentioanims = {
    [CHAR_ANIM_RUNNING] = 'dimentio_run',
}


if _G.charSelectExists then
    CT_OCHUNKS = _G.charSelect.character_add("O' Chunks", 
    "It's O'Chunks, the count's hulking, wide-eyed henchman! Word is, the count saved his life. Now he owes him big. Voiced by Mastergun117", "Melzinoff & Mastergun117", {r = 167, g = 83, b = 10}, E_MODEL_OCHUNKS, CT_MARIO, TEX_OCHUNKS)
    
    CT_MIMI = _G.charSelect.character_add("Mimi", 
    "It's Mimi, the adorable, yet slightly unstable shape-shifter!  Voiced by Lenophie", "Melzinoff & Lenophie", {r = 162, g = 226, b = 41}, E_MODEL_MIMI_DEFAULT, CT_MARIO, TEX_MIMI)

    CT_DIMENTIO = _G.charSelect.character_add("Dimentio", 
    "It's Mimi, the adorable, yet slightly unstable shape-shifter!  Voiced by Melzinoff", "Melzinoff", {r = 255, g = 158, b = 255}, E_MODEL_DIMENTIO, CT_MARIO, TEX_DIMENTIO)

    CT_MRL = _G.charSelect.character_add("Mr L", 
    "He calls himself the Green Thunder, but Mr. L's true identity is a mystery, forever concealed beneath his stylish green hat. With his incredible skill of jumping really high, he makes a valuable addition to Count Bleck's evil forces.", "Melzinoff", {r = 1, g = 255, b = 57}, E_MODEL_MRL, CT_LUIGI, TEX_MRL)

    CT_NASTASIA = _G.charSelect.character_add("Nastasia", 
    "Nastasia is Count Bleck's executive assistant. She's in charge of scheduling, organizing, and brain-control. Word is, she's got a secret crush on her boss. Voiced by GauntletQueen", "Melzinoff & GauntletQueen", {r = 255, g = 101, b = 243}, E_MODEL_NASTASIA, CT_MARIO, TEX_NASTASIA)

    CT_CBLECK = _G.charSelect.character_add("Count Bleck", 
    "This top-hatted villain is bent on ending the world! Fun fact: he was once known as Count Blumiere. Voiced by LucinaOfStardust", "Melzinoff & LucinaofStardust", {r = 44, g = 80, b = 233}, E_MODEL_CBLECK, CT_MARIO, TEX_CBLECK)


    _G.charSelect.character_add_caps(E_MODEL_OCHUNKS, capOCHUNKS)
    _G.charSelect.character_add_caps(E_MODEL_OCHUNKS_STEM, capOCHUNKS)
    
    _G.charSelect.character_add_caps(E_MODEL_MIMI_DEFAULT, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_MAID, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_ADVENTURE, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_BANK, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_BEACH, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_CHEER, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_FORMAL, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_POST, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_SAMMER, capMIMI)
    _G.charSelect.character_add_caps(E_MODEL_MIMI_SUIT, capMIMI)

    _G.charSelect.character_add_caps(E_MODEL_CBLECK, capCBLECK)

    _G.charSelect.character_add_caps(E_MODEL_MRL, capMRL)
    _G.charSelect.character_add_caps(E_MODEL_SHADOO, capSHADOO)

    _G.charSelect.character_add_caps(E_MODEL_NASTASIA, capNASTASIA)

    _G.charSelect.character_add_caps(E_MODEL_DIMENTIO, capDIMENTIO)


    _G.charSelect.character_add_palette_preset(E_MODEL_OCHUNKS, PALETTE_OCHUNKS)
    _G.charSelect.character_add_palette_preset(E_MODEL_OCHUNKS_STEM, PALETTE_OCHUNKS_STEM)

    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_DEFAULT, PALETTE_MIMI_DEFAULT)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_MAID, PALETTE_MIMI_MAID)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_ADVENTURE, PALETTE_MIMI_ADVENTURE)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_BANK, PALETTE_MIMI_BANK)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_BEACH, PALETTE_MIMI_BEACH)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_CHEER, PALETTE_MIMI_CHEER)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_FORMAL, PALETTE_MIMI_FORMAL)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_POST, PALETTE_MIMI_POST)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_SAMMER, PALETTE_MIMI_SAMMER)
    _G.charSelect.character_add_palette_preset(E_MODEL_MIMI_SUIT, PALETTE_MIMI_SUIT)

    _G.charSelect.character_add_palette_preset(E_MODEL_CBLECK, PALETTE_CBLECK)

    _G.charSelect.character_add_palette_preset(E_MODEL_MRL, PALETTE_MRL)
    _G.charSelect.character_add_palette_preset(E_MODEL_SHADOO, PALETTE_SHADOO)

    _G.charSelect.character_add_palette_preset(E_MODEL_NASTASIA, PALETTE_NASTASIA)

    _G.charSelect.character_add_palette_preset(E_MODEL_DIMENTIO, PALETTE_DIMENTIO)

    _G.charSelect.character_add_costume(CT_OCHUNKS, "O'Cabbage", nil, nil, nil, E_MODEL_OCHUNKS_STEM, nil, nil, nil, nil)
    _G.charSelect.character_add_costume(CT_MRL, "Shadoo", "A monster created by ancients and hidden deep within the Flopside Pit of 100 Trials, it has copied Luigi, planning to replace him!", "Melzinoff", {r = 67, g = 67, b = 67}, E_MODEL_SHADOO, CT_LUIGI, TEX_SHADOO, nil, nil)


    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_POST, E_MODEL_STAR_1PH, TEX_STAR_1PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_OCHUNKS, E_MODEL_STAR_1PH, TEX_STAR_1PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_DEFAULT, E_MODEL_STAR_2PH, TEX_STAR_2PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_MAID, E_MODEL_STAR_2PH, TEX_STAR_2PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_BANK, E_MODEL_STAR_2PH, TEX_STAR_2PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_ADVENTURE, E_MODEL_STAR_3PH, TEX_STAR_3PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_DIMENTIO, E_MODEL_STAR_3PH, TEX_STAR_3PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MRL, E_MODEL_STAR_4PH, TEX_STAR_4PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_FORMAL, E_MODEL_STAR_4PH, TEX_STAR_4PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_OCHUNKS_STEM, E_MODEL_STAR_5PH, TEX_STAR_5PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_SUIT, E_MODEL_STAR_5PH, TEX_STAR_5PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_SAMMER, E_MODEL_STAR_6PH, TEX_STAR_6PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_CHEER, E_MODEL_STAR_7PH, TEX_STAR_7PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_NASTASIA, E_MODEL_STAR_8PH, TEX_STAR_8PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_MIMI_BEACH, E_MODEL_STAR_8PH, TEX_STAR_8PH)
    _G.charSelect.character_add_celebration_star(E_MODEL_CBLECK, E_MODEL_STAR_DARKPH, TEX_STAR_DARKPH)
    _G.charSelect.character_add_celebration_star(E_MODEL_SHADOO, E_MODEL_STAR_7PH, TEX_STAR_7PH)


    --_G.charSelect.character_add_health_meter(CT_OCHUNKS, PM_OCHUNKS)

    do
        -- table of skins
        local SKINTABLE_BY = {
            { model = E_MODEL_MIMI_MAID,  name = "Mimi (Maid)"},
            { model = E_MODEL_MIMI_BANK,  name = "Mimi (Bank)"},
            { model = E_MODEL_MIMI_ADVENTURE,  name = "Mimi (Explorer)"},
            { model = E_MODEL_MIMI_FORMAL,  name = "Mimi (Gala)"},
            { model = E_MODEL_MIMI_SUIT,  name = "Mimi (Suit)"},
            { model = E_MODEL_MIMI_SAMMER,  name = "Mimi (Kimono)"},
            { model = E_MODEL_MIMI_CHEER,  name = "Mimi (Cheerleader)"},
            { model = E_MODEL_MIMI_BEACH,  name = "Mimi (Beach)"},
            { model = E_MODEL_MIMI_POST,  name = "Mimi (Soiree)"},
            }
    
        for index, alt in ipairs(SKINTABLE_BY) do
            _G.charSelect.character_add_costume(CT_MIMI, alt.name, nil, nil, nil, alt.model, nil, nil, nil, nil)
        end
    end

    _G.charSelect.character_add_animations(E_MODEL_CBLECK, cbleckanims)
    _G.charSelect.character_add_animations(E_MODEL_DIMENTIO, dimentioanims)

    hook_event(HOOK_UPDATE, function()
        -- flag to determine if a player is daisy (boolean)
        -- this is done in the local update hook because character select can only check for the local player's numbers
        -- gPlayerSyncTable auto syncs the result to all clients
        gPlayerSyncTable[0].dimentioplayer = (_G.charSelect.character_get_current_number() == CT_DIMENTIO)
    end)
    local DIMENTIO_ACT_TABLE = {
        { act = ACT_BACKFLIP_LAND },
        { act = ACT_BUBBLED },
        { act = ACT_BACKFLIP},
        { act = ACT_BURNING_FALL },
        { act = ACT_BACKFLIP_LAND_STOP },
        { act = ACT_BURNING_GROUND },
        { act = ACT_BURNING_JUMP },
        { act = ACT_BUTT_SLIDE_STOP },
        { act = ACT_BUTT_STUCK_IN_GROUND },
        { act = ACT_CAUGHT_IN_WHIRLPOOL },
        { act = ACT_CLIMBING_POLE },
        { act = ACT_CRAWLING },
        { act = ACT_CRAZY_BOX_BOUNCE },
        { act = ACT_ELECTROCUTION },
        { act = ACT_END_WAVING_CUTSCENE },
        { act = ACT_HANGING },
        { act = ACT_HANG_MOVING },
        { act = ACT_HEAVY_THROW },
        { act = ACT_HOLDING_BOWSER },
        { act = ACT_HOLDING_POLE },
        { act = ACT_LAVA_BOOST },
        { act = ACT_LAVA_BOOST_LAND },
        { act = ACT_LEDGE_GRAB },
        { act = ACT_LEDGE_CLIMB_FAST },
        { act = ACT_LEDGE_CLIMB_SLOW_1 },
        { act = ACT_LEDGE_CLIMB_DOWN },
        { act = ACT_LEDGE_CLIMB_SLOW_2 },
        { act = ACT_MOVE_PUNCHING },
        { act = ACT_PICKING_UP },
        { act = ACT_PICKING_UP_BOWSER },
        { act = ACT_PLACING_DOWN },
        { act = ACT_PULLING_DOOR },
        { act = ACT_PUNCHING },
        { act = ACT_PUSHING_DOOR },
        { act = ACT_RELEASING_BOWSER },
        { act = ACT_RIDING_HOOT },
        { act = ACT_SHIVERING },
        { act = ACT_THROWING },
        { act = ACT_TOP_OF_POLE },
        { act = ACT_TOP_OF_POLE_TRANSITION },
        { act = ACT_TORNADO_TWIRLING },
        { act = ACT_TRIPLE_JUMP_LAND },
        { act = ACT_TRIPLE_JUMP_LAND_STOP },
        { act = ACT_UNLOCKING_STAR_DOOR },
        { act = ACT_UNLOCKING_KEY_DOOR },
        { act = ACT_WATER_PUNCH },
        { act = ACT_HOLD_FREEFALL},
        { act = ACT_HOLD_FREEFALL_LAND },
        { act = ACT_HOLD_FREEFALL_LAND_STOP },
        { act = ACT_HOLD_HEAVY_IDLE },
        { act = ACT_HOLD_HEAVY_WALKING },
        { act = ACT_HOLD_IDLE },
        { act = ACT_HOLD_JUMP },
        { act = ACT_HOLD_JUMP_LAND },
        { act = ACT_HOLD_JUMP_LAND_STOP },
        { act = ACT_HOLD_METAL_WATER_FALLING },
        { act = ACT_HOLD_METAL_WATER_FALL_LAND },
        { act = ACT_HOLD_METAL_WATER_JUMP },
        { act = ACT_HOLD_METAL_WATER_JUMP_LAND },
        { act = ACT_HOLD_METAL_WATER_STANDING },
        { act = ACT_HOLD_METAL_WATER_WALKING },
        { act = ACT_HOLD_WALKING },
        { act = ACT_HOLD_BUTT_SLIDE_STOP },
        { act = ACT_HOLD_DECELERATING },
        { act = ACT_HOLD_FLUTTER_KICK },
        { act = ACT_HOLD_BEGIN_SLIDING },
        { act = ACT_HOLD_BREASTSTROKE },
        { act = ACT_HOLD_STOMACH_SLIDE },
        { act = ACT_HOLD_SWIMMING_END },
        { act = ACT_HOLD_WATER_ACTION_END },
        { act = ACT_HOLD_WATER_IDLE },
        { act = ACT_HOLD_WATER_JUMP },
    }
    ---@param m MarioState
    function mario_update(m)
        if gPlayerSyncTable[m.playerIndex].dimentioplayer then
            for index, actcheck in ipairs(DIMENTIO_ACT_TABLE) do
                if m.action == actcheck.act then
                    m.marioBodyState.handState = 1
                end
            end


        end
    end

hook_event(HOOK_MARIO_UPDATE, mario_update)


hook_event(HOOK_ON_PLAY_SOUND, function(sound)
    local m = gMarioStates[0]
        if gPlayerSyncTable[m.playerIndex].dimentioplayer then
            if (sound == (SOUND_ACTION_TERRAIN_STEP + m.terrainSoundAddend)) and m.action == ACT_WALKING then
                return NO_SOUND
            end
        end
end)


    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_OCHUNKS, VOICETABLE_OCHUNKS)
    _G.charSelect.character_add_voice(E_MODEL_OCHUNKS_STEM, VOICETABLE_OCHUNKS)

    _G.charSelect.character_add_voice(E_MODEL_MIMI_DEFAULT, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_MAID, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_BANK, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_ADVENTURE, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_FORMAL, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_SUIT, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_SAMMER, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_CHEER, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_BEACH, VOICETABLE_MIMI)
    _G.charSelect.character_add_voice(E_MODEL_MIMI_POST, VOICETABLE_MIMI)

    _G.charSelect.character_add_voice(E_MODEL_CBLECK, VOICETABLE_CBLECK)

    _G.charSelect.character_add_voice(E_MODEL_NASTASIA, VOICETABLE_NASTASIA)

    _G.charSelect.character_add_voice(E_MODEL_DIMENTIO, VOICETABLE_DIMENTIO)



    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_OCHUNKS then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MIMI then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CBLECK then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_NASTASIA then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_DIMENTIO then return _G.charSelect.voice.sound(m, sound) end

    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_OCHUNKS then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MIMI then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CBLECK then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_NASTASIA then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_DIMENTIO then return _G.charSelect.voice.snore(m) end

    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end
